﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Net.Security;
using System.ServiceModel;
using HeuristicLab.Services.ClientManagement.DataTransfer;

namespace HeuristicLab.Services.ClientManagement {
  [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
  public interface IClientManagementService {

    #region Client
    Client GetClient(Guid id);

    IEnumerable<Client> GetClients();

    IEnumerable<Client> GetClientsOfGroup(Guid id);

    Guid AddClient(Client dto);

    void UpdateClient(Client dto);

    void DeleteClient(Client dto);
    #endregion

    #region Group
    Group GetGroup(Guid id);

    IEnumerable<Group> GetGroups();

    IEnumerable<Group> GetGroupsOf(Guid clientId);

    Guid AddGroup(Group dto);

    void UpdateGroup(Group dto);

    void DeleteGroup(Group dto);
    #endregion

    #region Resource
    IEnumerable<Resource> GetResources();

    IEnumerable<Resource> GetMembers(Guid groupId);
    #endregion

    #region ClientLog
    ClientLog GetLastClientLog(Guid clientId);

    IEnumerable<ClientLog> GetClientLogs(Guid clientId);

    IEnumerable<ClientLog> GetClientLogsSince(DateTime startDate);

    void AddClientLogEntry(ClientLog log);

    void DeleteClientLogEntry(DateTime timeStamp, Guid resourceId);
    #endregion
  }
}
